init:

    image bg pong field = "pong_field.png"

    python:
        
        from string import uppercase 
        def getAnswer( clue, rightAnswer, hint, hints ):
            if ( hints == 0 ):
                val = renpy.input(clue + ": Your guess?" ).upper()
            else:
                val = renpy.input( clue + " HINT: use these letters [" + hint  +"]: Enter your guess?  Press enter to skip.").upper()
            return val == rightAnswer


        import pygame
        from copy import copy
        import random
        
        class PongMinigame(object):

            def __init__(self, filename, sizeX, sizeY ):
                # The minigame object, initialized with the methods it calls
                # for various events.
                self.minigame = renpy.Minigame(self.render, self.event)

                self.unselectedP = True
                
                self.ending = 0
                    
                self.starting = 1

                self.filename = filename
                self.pi = self.minigame.load_image( filename )
                
                self.pWidth = self.pi.get_width()
                self.pHeight = self.pi.get_height()
                
                self.sizeX = sizeX
                self.sizeY = sizeY
                self.pieceWidth = self.pWidth/(self.sizeX)
                self.pieceHeight = self.pHeight/(self.sizeY)
                
                self.hilighted = -1
                self.mode = "GRAB"
                self.puzzState = [ ];
                
                for j in range( 0, self.sizeY ):
                    for i in range( 0, self.sizeX ):
                        self.puzzState.append( i + j* self.sizeY );
                        
                # scramble the puzzle
                
                if ( True ):
                    for i in range( 0, 200 ):
                        start = random.randint( 0, len( self.puzzState) -1 )
                        end = random.randint( 0, len( self.puzzState) -1 )
                        if ( start != end ):
                            swap = self.puzzState[ start ]
                            self.puzzState[ start ] = self.puzzState[ end ]
                            self.puzzState[ end ] = swap
                else:
                    self.puzzState[ 0 ] = 2
                    self.puzzState[ 2 ] = 0
                
                # easy scramble
                self.currentSquare = ( 0, 0 )
                self.toUL = self.toLR = ( 0, 0 )
                self.ul = (0,0)
                self.lr = (0,0)
                self.xStart = 0
                self.xTarget = self.length = self.copySquareDebug  = 0
                self.duplicates = self.debugCopies = []
                self.coloredSquares = {}
                self.coloredSquares[ "blue" ] = []
                self.coloredSquares[ "red" ] = []
                 
                self.subsurfs = [];
                
                f = open( "debug.txt", "w+")
                
                for j in range( 0, self.sizeY ):
                    for i in range( 0, self.sizeX ):
                            f.write( "i = " + str( i ) + " j " + str( j ) ) 
                            
                            f.write( "pieceWidth = " + str( self.pieceWidth ) + "\n")
                            f.write( "pieceWidth * i= " + str( self.pieceWidth  * i + self.pieceWidth -1 ) + "\n")
                            f.write( "pieceHeight = " + str( self.pieceHeight ) + "\n")
                            f.write( "pieceHeight * j= " + str( self.pieceHeight  * j + self.pieceHeight-1) + "\n")
                            f.flush()
                            area = pygame.Rect( self.pieceWidth * i, self.pieceHeight* j, self.pieceWidth,  self.pieceHeight )
                            sf = self.pi.subsurface( area )
                            self.subsurfs.append( sf )
                            f.write( "subsurf=" + str( self.subsurfs[ 0 ] ) + " " + str( area ) + "\n" )
                            
                area = pygame.Rect( 0, 0, min( 500, self.pieceWidth + 2), min( 500, self.pieceHeight + 2) )
                            
                self.redAlpha = self.minigame.load_image("red-alpha.png")
                self.redAlpha = self.redAlpha.subsurface( area )
                self.blueAlpha = self.minigame.load_image("blue-alpha.png").subsurface( area )
                
                self.theAreaWidth = 600
                theArea = pygame.Rect( 0, 0, self.theAreaWidth, 30 )
                
                self.textBackground = self.minigame.load_image( "Marie/bar.png").subsurface( theArea )
                
            def drawBlueMarker( self, r, x, y ):
                #ball = self.minigame.load_image("pong_ball.png")
                r.blit(self.blueAlpha, (x * self.pieceWidth, y * self.pieceHeight ) )
            
            def drawMarker( self, r, x, y ):
                #ball = self.minigame.load_image("pong_ball.png")
                r.blit(self.redAlpha, (x * self.pieceWidth, y * self.pieceHeight ) )
            
            def drawWord( self, r, text, loc ):
                
                player = self.minigame.render_text(text,
                                                   style.default.font,
                                                   36,
                                                   "#f3f")
                                                   
                r.blit(player, ( loc[ 0 ] * self.pieceWidth, loc[ 1] * self.pieceHeight))

                
            def drawOriginalArea( self, r, ul, lr ):
                for i in range( ul[ 0 ], lr[ 0 ] + 1 ):
                    for j in range( ul[ 1 ], lr[ 1 ] + 1):
                        self.drawBlueMarker( r, i, j );
                
            def drawHilight( self, r, ul, lr ):
                for i in range( ul[ 0 ], lr[ 0 ] + 1 ):
                    for j in range( ul[ 1 ], lr[ 1 ] + 1):
                        self.drawMarker( r, i, j );
                        
            def squareToCoord( self, dup ):
                y = dup / self.sizeY
                return ( dup - y * self.sizeY, y )
                
            def drawDuplicate( self, r, dup ):
                loc = self.squareToCoord( dup )
                self.drawMarker( r, loc[ 0 ], loc[ 1 ] )
                
            def drawDebugCopies( self, r, dbc ):
                loc1 = self.squareToCoord( dbc[ 0 ] )
                loc2 = self.squareToCoord( dbc[ 1 ] )
#                self.drawWord( r, dbc[ 2 ], loc1 )
#                self.drawWord( r, dbc[ 2 ], loc2 )
                
            def pointInSquareP( self, point, squareUL, squareLR ):
                return ( point[ 0 ] >= squareUL[ 0 ]
                            and point[ 0 ] <= squareLR[ 0 ]
                            and point[ 1 ] >= squareUL[ 1 ]
                            and point[ 1 ] <= squareLR[ 1 ] )
                            
            def copySquare( self, fromUL, fromLR, toUL, toLR, fromState, toState, debug ):
                xSize = fromLR[ 0 ] - fromUL[ 0 ] + 1
                ySize = fromLR[ 1 ] - fromUL[ 1 ] + 1 
                self.copySquareDebug = "\n" + str( fromUL ) + " " + str( fromLR ) + " "  + str( (xSize, ySize) )
                for i in range( 0, xSize):
                    for j in range( 0, ySize ):
                        xf = i + fromUL[ 0 ]
                        yf = j + fromUL[ 1 ]
                        
                        xt = i + toUL[ 0 ]
                        yt = j + toUL[ 1 ]
                        toState[ xt + yt*self.sizeY  ] = fromState[ xf + yf*self.sizeY  ]
                        
                        self.debugCopies.append( ( xt + yt*self.sizeY, xf + yf*self.sizeY, debug ) )
                        if ( color != 0 ):
                            self.coloredSquares[ "blue" ].append( ( xt, yt ) )
                             
                        
            def generateCandidateState( self ):
                fromUL = self.ul
                fromLR = self.lr
                
                self.duplicates = []
                self.debugCopies = []
                
                self.coloredSquares = {}
                self.coloredSquares[ "blue" ] = []
                self.coloredSquares[ "red" ] = []
            
                # X and Y aliged overlaps don't work backwards.
    
                areaXSize = fromLR[ 0 ]+1 - fromUL[ 0 ]
                areaYSize = fromLR[ 1 ]+1 - fromUL[ 1 ]
                
                # this isn't calculated right; must find the correct
                # offset based on last position of cursor
                toUL = self.toUL = ( self.currentSquare[ 0 ] - areaXSize + 1, self.currentSquare[ 1 ] - areaYSize  + 1) 
                toLR = self.toLR = ( self.currentSquare[ 0 ], self.currentSquare[ 1 ] )
                
                possibleState = copy( self.puzzState )
                
                # move target state over
                
               #Case -1: Exactly the same
                if ( fromUL == toUL and fromLR == toLR ):
                    
                    for i in range( fromUL[ 0 ], toLR[ 0 ]+1 ):
                        for j in range( fromUL[ 1 ], toLR[ 1 ] + 1 ):
                            self.coloredSquares[ "red" ].append( ( i, j ) )
                    return possibleState
 
                fromUR = [ fromLR[ 0 ], fromUL[ 1 ] ] 
                fromLL = [ fromUL[ 0 ], fromLR[ 1 ] ] 
                #Case 0: No overlap
                if not ( self.pointInSquareP( fromUL, toUL, toLR )
                    or self.pointInSquareP( fromLR, toUL, toLR )
                    # Check for over the shoulder stuff
                    or self.pointInSquareP( fromUR, toUL, toLR )
                    or self.pointInSquareP( fromLL, toUL, toLR ) ): 
                    
                    self.copySquare( toUL, toLR, fromUL, fromLR, self.puzzState, possibleState, "NO" )
                    
                # case 2: X-aligned overlap
                elif ( fromUL[ 0 ] == toUL[ 0 ] ):
                    yStart = yTarget = 0
                    
                    if fromUL[ 1 ] < toUL[ 1 ]:
                        yStart = fromLR[ 1 ] + 1
                        yTarget = fromUL[ 1 ]
                        length = toUL[ 1 ] - fromUL[ 1 ]
                    else:
                        yStart = toUL[ 1 ]
                        yTarget = toLR[ 1 ] + 1
                        length = fromUL[ 1 ] - toUL[ 1 ] 
                    
                    length = length - 1
                    self.length = length
                    
                    self.xStart = yStart
                    self.xTarget = yTarget
                    
                    # Remember in this case, toUL[ 0 ] and fromUL[ 0 ] are equal
                    self.copySquare( (toUL[ 0 ], yStart ), (toLR[ 0 ], yStart + length ),
                                        ( fromUL[ 0 ], yTarget ), (fromLR[ 0 ], yTarget + length), 
                                        self.puzzState, possibleState, "X" )
                    
                # case 3: Y-aligned overlap
                elif ( fromUL[ 1 ] == toUL[ 1 ] ):
                    xStart = xTarget = 0
                    
                    if fromUL[ 0 ] < toUL[ 0 ]:
                        xStart = fromLR[ 0 ] + 1
                        xTarget = fromUL[ 0 ]
                        length = toUL[ 0 ] - fromUL[ 0 ]
                    else:
                        xStart = toUL[ 0 ]
                        xTarget = toLR[ 0 ] + 1
                        length = fromUL[ 0 ] - toUL[ 0 ] 
                    
                    self.xStart = xStart
                    self.xTarget = xTarget
                    
                    length = length-1
    
                    self.length = length
                    
                    # Remember in this case, toUL[ 1 ] and fromUL[ 1 ] are equal
                    self.copySquare( (xStart, toUL[ 1 ]), (xStart  + length, toLR[ 1 ] ),
                                        ( xTarget, fromUL[ 1 ] ), (xTarget + length, fromLR[ 1 ]  ), 
                                        self.puzzState, possibleState, "Y" )

                # case 4: crooked overlap
                else:
                    # Two parts: xdiff, ydiff
                    xStart = xTarget = 0
                    
                    if fromUL[ 0 ] < toUL[ 0 ]:
                        xStart = fromLR[ 0 ] + 1
                        xTarget = fromUL[ 0 ]
                        length = toUL[ 0 ] - fromUL[ 0 ]
                    else:
                        xStart = toUL[ 0 ]
                        xTarget = toLR[ 0 ] + 1
                        length = fromUL[ 0 ] - toUL[ 0 ] 
                    
                    self.xStart = xStart
                    self.xTarget = xTarget
                    
                    
                    length = length-1 
                    xlength = length + 1
    
                    self.length = length
                    
                    # Remember in this case, toUL[ 1 ] and fromUL[ 1 ] are different
                    self.copySquare( (xStart, toUL[ 1 ]), (xStart  + length, toLR[ 1 ] ),
                                        ( xTarget, fromUL[ 1 ]), (xTarget + length, fromLR[ 1 ]  ), 
                                        self.puzzState, possibleState, "1" )
                                        
                    
                    # ydiff for size
                    yStart = yTarget = 0
                    
                    if fromUL[ 1 ] < toUL[ 1 ]:
                        yStart = fromLR[ 1 ] + 1
                        yTarget = fromUL[ 1 ]
                        length = toUL[ 1 ] - fromUL[ 1 ]
                    else:
                        yStart = toUL[ 1 ]
                        yTarget = toLR[ 1 ] + 1
                        length = fromUL[ 1 ] - toUL[ 1 ] 
                        
                    xOffsetFrom = 0
                    xOffsetTo = 0
                    if ( fromUL[ 0 ] < toUL[ 0 ] ):
                        xOffsetFrom = xlength
                    else:
                        xOffsetTo = xlength
                    
                    length = length - 1
                    xCopyLength = abs(  fromUL[ 0 ] - fromLR[ 0 ] ) - xlength 
                    
                    # Remember in this case, toUL[ 0 ] and fromUL[ 0 ] are different
                    self.copySquare( (toUL[ 0 ] + xOffsetTo, yStart ), (toUL[ 0 ] + xOffsetTo + xCopyLength, yStart + length ),
                                        ( fromUL[ 0 ] + xOffsetFrom, yTarget ), (fromUL[ 0 ] + xOffsetFrom + xCopyLength , yTarget + length), 
                                        self.puzzState, possibleState, "2" )

                    # Inversion code
#                    for i in range( 0, areaXSize):
 #                       for j in range( 0, areaYSize ):
  #                          xf = i + fromUL[ 0 ]
   #                         yf = j + fromUL[ 1 ]
                        
   #                         xt = toLR[ 0 ] - i 
    #                        yt = toLR[ 1 ] - j 
     #                       possibleState[ xf + yf*self.sizeY   ] = self.puzzState[ xt + yt*self.sizeY  ]
 
               # Copy target stuff to copyfrom area
                for i in range( 0, areaXSize):
                    for j in range( 0, areaYSize ):
                        xf = i + fromUL[ 0 ]
                        yf = j + fromUL[ 1 ]
                        
                        xt = i + toUL[ 0 ]
                        yt = j + toUL[ 1 ]
                        possibleState[ xt + yt*self.sizeY  ] = self.puzzState[ xf + yf*self.sizeY  ]
                        self.coloredSquares[ "red" ].append( ( xt, yt ) )
  
                #Copy possible to puzzStat
                # Mark duplicates
                self.duplicates = []
                for i in range( 0, len( self.puzzState ) ):
                    count = 0
                    for j in range( 0, len( self.puzzState ) ):
                        if possibleState[ j ] == i:
                            count = count + 1
                            if( count > 1 ):
                                self.duplicates.append( j )
                    
              
                return possibleState;
                
            # draws the screen.
            def render(self, r, st):
                import pygame
                
                def showPicture():
                    for j in range( 0, self.sizeY ):
                        for i in range( 0, self.sizeX ):
                            x = self.pieceWidth * i;
                            y = self.pieceHeight* j;
                            
                            #r.blit( self.subsurfs[ i + j * self.sizeY ], (x , y ))
                            if ( self.mode == "GRAB" ):
                                r.blit( self.subsurfs[ self.puzzState[ i + j*self.sizeY ]], (x, y))
                                self.coloredSquares = {}
                                self.coloredSquares[ "blue" ] = []
                                self.coloredSquares[ "red" ] = []
            
                            elif ( self.mode == "MOVE" ):
                                state = self.generateCandidateState();
                                r.blit( self.subsurfs[ state[ i + j*self.sizeY ]], (x, y))
                                
                            if ( self.hilighted != -1 ):
                                if ( self.unselectedP == False and self.mouseDown and self.mode == "GRAB" ):
                                    self.drawHilight( r, self.ul, self.lr )
                showPicture()
                   
                #for duplicate in self.duplicates:
                 #   self.drawDuplicate( r, duplicate )
                    
                for debugCopy in self.debugCopies:
                    self.drawDebugCopies( r, debugCopy )
                    
                for square in self.coloredSquares[ "red" ]:
                    self.drawMarker( r, square[ 0 ], square[ 1 ] )
                
                for square in self.coloredSquares[ "blue" ]:
                    self.drawBlueMarker(r, square[ 0 ], square[ 1 ] )
                    
                if ( self.starting == 1 ):
                
                
                    ui.vbox(xalign=0.5, ypos = 170 )
                    ui.textbutton("You got it!  Click to continue...", clicked=ui.returns(1))
                    ui.close()
                    
                    ctb = self.minigame.render_text("Do the puzzle!  You can drag to select multiple pieces.",
                                                    style.default.font,
                                                    22,
                                                    "#ffe1b1")

                    cw, ch = ctb.get_size()
                    r.blit(self.textBackground, ( 400-self.theAreaWidth/2, 148 ) )
            
                    r.blit(ctb, (400 - cw / 2, 150)) 
                    
                    
                    
   #                 ctb = self.minigame.render_text("Do the puzzle!",
       #                                             style.default.font,
     #                                               36,
         #                                           "#fff")

           #         cw, ch = ctb.get_size()
             #       r.blit(ctb, (400 - cw / 2 + 2, 32)) 

                # Show Eileen's name.
                    
#                      eileen = self.minigame.render_text("Eileen",
 #                                                   style.default.font,
  #                                                  36,
   #                                                 "#fff")
    #            ew, eh = eileen.get_size()
     #           r.blit(eileen, (790 - ew, 25))
                
            
#                blah = self.minigame.render_text("Current Square: " + str( self.currentSquare ) + " UL: " + str( self.ul ) + " LR: " + str( self.lr ) + " toUL:" + str( self.toUL ) + " toLR: " + str( self.toLR ) + " xStart: " + str( self.xStart ) + " xTarget:" + str( self.xTarget ) + " length:" + str( self.length ) + "copySquare:" + str( self.copySquareDebug ),
#                                                    style.default.font,
#                                                    12,
#                                                    "#000")
#                ew, eh = blah.get_size()
#                r.blit(blah, (790 - ew, 95))
   
#                blah = self.minigame.render_text( str( self.puzzState ) + "Hilighted: " + str( self.hilighted ),
#                                                    style.default.font,
#                                                    12,
#                                                    "#000")
#                ew, eh = blah.get_size()
#                r.blit(blah, (790 - ew, 75))
   
                
                self.minigame.redraw()
                
            def checkForSafeScreenToSquare( self, realXY, selectedSize ):
                y = realXY[ 1 ]
                x = realXY[ 0 ]
                if ( y < selectedSize[ 1 ]-1 ): y = selectedSize[ 1 ]-1
                if ( x < selectedSize[ 0 ]-1 ): x = selectedSize[ 0 ]-1 
                    
                if ( x > self.sizeX-1 ): x= self.sizeX-1
                if ( y > self.sizeY-1 ): y= self.sizeY-1
                
                return ( x, y )
                
            def screenToSquare( self, x, y ):
                x = int( x/self.pieceWidth)
                y = int( y/self.pieceHeight )
                
                return (x, y)
                
            def doPaste( self, fromSquare, toSquare ):
                # These are two tuples; must be clever...
                # Convert tuple to absolute square
                self.puzzState = self.generateCandidateState()
                self.coloredSquares = {}
                self.coloredSquares[ "blue" ] = []
                self.coloredSquares[ "red" ] = []
            
                

            # Handles events.
            def event(self, ev, x, y, st):

                import pygame

                # Mousebutton down == start the game by setting stuck to
                # false.
                if ( self.starting == 0 ):
                    if ev.type == pygame.MOUSEBUTTONDOWN and ev.button == 1:
                        self.mouseDown = True
                        if ( self.unselectedP == True and self.mode == "GRAB" ):
                            self.unselectedP = False;
                            self.hilighted = self.screenToSquare( x, y );
                            self.ul = self.lr = self.screenToSquare( x, y )
                        elif self.mode == "MOVE":
                            self.doPaste( self.hilighted, self.checkForSafeScreenToSquare( self.screenToSquare( x, y ),  self.selectedSize ) )
                            self.unselectedP = True
                            self.hilighted = -1
                    
                    if ev.type == pygame.MOUSEBUTTONUP and ev.button == 1:
                        self.mouseDown = False
                        if ( self.mode == "GRAB" ):
                            self.mode = "MOVE"
                        else:
                            self.mode = "GRAB"
                    
                    if self.unselectedP == False and self.mouseDown and self.mode == "GRAB":
                        val = self.screenToSquare( x, y )
                        if ( val[ 0 ]>= self.ul[ 0 ] and val[ 1 ] >= self.ul[ 1 ] ):
                            self.lr = val
                
                if ( self.hilighted == -1 ):
                    self.selectedSize = ( 0, 0 )
                else:
                    areaXSize = self.lr[ 0 ]+1 - self.ul[ 0 ]
                    areaYSize = self.lr[ 1 ]+1 - self.ul[ 1 ]
                
                    self.selectedSize = (areaXSize, areaYSize) 
                
                self.currentSquare = self.checkForSafeScreenToSquare( self.screenToSquare( x, y ),  self.selectedSize )
                            
                if ev.type == pygame.MOUSEBUTTONUP and self.starting == 1:
                    renpy.music.set_volume(1.0, channel=7)
                    renpy.music.play("sound/puzzleSolver-short2.mp3", loop=True)
                
                    self.starting = 0
                elif ev.type == pygame.MOUSEBUTTONUP and self.ending == 1:
                    self.ending = 0
                    renpy.music.stop()
                    # self.minigame.ignore_event()
                    return True
                                    
                    
                # Set the position of the player's paddle.
                #y = max(y, self.COURT_TOP)
                #y = min(y, self.COURT_BOTTOM)
                
                winner = True
                
                for i in range( 0, len( self.puzzState ) ):
                    if ( self.puzzState[ i ] != i ):
                        winner = False
                
                if winner:
                    self.ending = 1
                    style.default.drop_shadow = (0, 0)
                
                    
                else:
                    self.minigame.ignore_event()
            

label minigame:

    # Put up the pong background, in the usual fashion.
 
    # Run the pong minigame, and determine the winner.
    python:
        pm = PongMinigame( "sven.png" )
        pm.minigame.run()

    return
    
label puzzleLotsOfSailors:
    
    python hide:
        pm = PongMinigame( "Marie/LetsGetThisPartyStarted800x600color.png", 4, 4 )
        pm.minigame.run()

    return
    
label puzzleSven:
 
    python hide:
        pm = PongMinigame( "Marie/sven800x600color.png", 5, 5 )
        pm.minigame.run()
 
    return
    
label puzzleTemple:
    python hide:
        pm = PongMinigame( "Marie/temple800x600color.png", 5, 5 )
        pm.minigame.run()

    return
    
label puzzleEmptyBed:
    python hide:
        pm = PongMinigame( "Marie/hotel800x600color.png", 3, 3 )
        pm.minigame.run()

    return
